#include "fastds-pure.h"
#include <sstream>

int main(int argc, char *argv[]) {
  uint seed;

  /*if (argc == 1) {
    cout << "A Minimum Dominating Set Problem solver." << endl;
    cout << "Usage: ./fastds [Graph file] [Seed] [Cutoff time]" << endl;
    return 1;
  }

  if (argc < 5) {
    cout << "A Minimum Dominating Set Problem solver." << endl;
    cerr << "\033[31mMissing argument(s).\033[0m" << endl;
    cout << "Usage: ./fastds [Graph file] [Seed] [Cutoff time]" << endl;
    return 1;
  }*/

  stringstream ss;
  ss << argv[2];
  ss >> seed;
  ss.clear();
  ss << argv[3];
  ss >> cutoff_time;
  ss.clear();
  ss << argv[4];
  ss >> para1;
  ss.clear();

  if (BuildInstance(argv[1]) != 0) {
    cerr << "Open instance file failed." << endl;
    return 1;
  }

  if (seed < 0U || seed > ~0U) {
    seed = 10;
  }

  if (cutoff_time < 0 || cutoff_time > (int)(~0U >> 1)) {
    cutoff_time = 1000;
  }

  srand(seed);

  cout << argv[1];

  start = chrono::steady_clock::now();
  
  //while(true)
  //{

  ConstructDS();
  //cout<<" "<<best_c_size<<endl;
  
  // cout<<"constructDS"<<best_c_size<<endl;
  LocalSearch();
  //}

  if (CheckSolution() == 1) {
    cout << ", " << best_c_size << ", " << best_comp_time << endl;
  } else {
    cout << ", the solution is wrong." << endl;
  }

  FreeMemory();

  return 0;
}
